//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <ipl.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // 1. Abrir la imagen original
  if (!OpenDialog1->Execute())
    return;
  IplImage *base= cvLoadImage(OpenDialog1->FileName.c_str());
  if (!base) {
    ShowMessage("No se puede leer el archivo de imagen.");
    return;
  }

  // 2. Pedir el nombre de destino e inicializar variables
  if (!SaveDialog1->Execute()) {
    cvReleaseImage(&base);
    return;
  }
  CvScalar colormedio= cvAvg(base);
  int numfilas= CSpinEdit1->Value;
  int numcolumnas= CSpinEdit1->Value;
  int anchores= 100, altores= anchores*base->height/base->width;
  IplImage *res= cvCreateImage(cvSize(numfilas*anchores, numcolumnas*altores),
                   base->depth, base->nChannels);
  CvRect roi, roi2;
  roi.width= anchores;
  roi.height= altores;
  roi2.width= (base->width+numfilas-1)/numfilas;
  roi2.height= (base->height+numcolumnas-1)/numcolumnas;

  // 3. Para cada parche de la imagen resultante
  for (int y= 0; y<numcolumnas; y++)
    for (int x= 0; x<numfilas; x++) {
      ProgressBar1->Position= 100*(y*numcolumnas+x)/(numcolumnas*numcolumnas);
      Application->ProcessMessages();
      // 3.1. Copiar la imagen original en el parche de destino
      roi.x= x*anchores;
      roi.y= y*altores;
      cvSetImageROI(res, roi);
      cvResize(base, res, CV_INTER_CUBIC);
      // 3.2. Calcular el color medio del trozo correspondiente al parche
      roi2.x= base->width*x/numfilas;
      roi2.y= base->height*y/numcolumnas;
      cvSetImageROI(base, roi2);
      CvScalar colortrozo= cvAvg(base);
      cvResetImageROI(base);
      // 3.3. Modificar el parche, para que su color medio coindica con
      //      el de la imagen original en ese trozo
      CvScalar colorsuma= cvScalar(colortrozo.val[0]-colormedio.val[0],
          colortrozo.val[1]-colormedio.val[1], colortrozo.val[2]-colormedio.val[2]);
      cvAddS(res, colorsuma, res);
      // 3.4. Mostrar el resultado parcial
      cvResetImageROI(res);
      cvNamedWindow("Resultado", 0);
      cvShowImage("Resultado", res);
    }

  // 4. Guardar la imagen resultante y liberar variables
  if (!cvSaveImage(SaveDialog1->FileName.c_str(), res))
    ShowMessage("No se puede escribir el resultado.");
  ProgressBar1->Position= 100;
  cvReleaseImage(&base);
  cvReleaseImage(&res);
}
//---------------------------------------------------------------------------


